Revert "fix(jobspec): Delete ipsec nfv density tests"
[csit.git] / resources / libraries / bash / function / per_patch.sh
index 83e8427..44bd57d 100644 (file)
@@ -1,4 +1,5 @@
-# Copyright (c) 2018 Cisco and/or its affiliates.
+# Copyright (c) 2023 Cisco and/or its affiliates.
+# Copyright (c) 2023 PANTHEON.tech s.r.o.
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at:
 
 set -exuo pipefail
 
-# This library defines functions used mainly by "per_patch_perf.sh" entry script.
+# This library defines functions used mainly by per patch entry scripts.
 # Generally, the functions assume "common.sh" library has been sourced already.
-
 # Keep functions ordered alphabetically, please.
 
-# TODO: Add a link to bash style guide.
-
 
-function archive_parse_test_results () {
-
-    set -exuo pipefail
+function build_vpp_ubuntu () {
 
-    # Arguments:
-    # - ${1}: Directory to archive to. Required. Parent has to exist.
-    # Variables read:
-    # - ARCHIVE_DIR - Path to where robot result files are created in.
-    # - VPP_DIR - Path to existing directory, root for to relative paths.
-    # Directories updated:
-    # - ${1} - Created, and robot and parsing files are moved/created there.
-    # Functions called:
-    # - die - Print to stderr and exit, defined in common.sh
-    # - parse_bmrr_results - See definition in this file.
-
-    cd "${VPP_DIR}" || die "Change directory command failed."
-    target="$(readlink -f "$1")"
-    mkdir -p "${target}" || die "Directory creation failed."
-    for filename in "output.xml" "log.html" "report.html"; do
-        mv "${ARCHIVE_DIR}/${filename}" "${target}/${filename}" || {
-            die "Attempt to move '${filename}' failed."
-        }
-    done
-    parse_bmrr_results "${target}" || {
-        die "The function should have died on error."
-    }
-}
-
-
-function build_vpp_ubuntu_amd64 () {
-
-    set -exuo pipefail
-
-    # This function is using Vagrant script to build VPP with all dependencies
+    # This function is using make pkg-verify to build VPP with all dependencies
     # that is ARCH/OS aware. VPP repo is SSOT for building mechanics and CSIT
     # is consuming artifacts. This way if VPP will introduce change in building
     # mechanics they will not be blocked by CSIT repo.
+    #
     # Arguments:
     # - ${1} - String identifier for echo, can be unset.
     # Variables read:
+    # - MAKE_PARALLEL_FLAGS - Make flags when building VPP.
+    # - MAKE_PARALLEL_JOBS - Number of cores to use when building VPP.
     # - VPP_DIR - Path to existing directory, parent to accessed directories.
     # Directories updated:
     # - ${VPP_DIR} - Whole subtree, many files (re)created by the build process.
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     cd "${VPP_DIR}" || die "Change directory command failed."
-    echo 'Building using "make build-root/vagrant/build.sh"'
-    build-root/vagrant/"build.sh" || die "Vagrant VPP build script failed."
-    echo "*******************************************************************"
+    if [ -n "${MAKE_PARALLEL_FLAGS-}" ]; then
+        echo "Building VPP. Number of cores for build set with" \
+             "MAKE_PARALLEL_FLAGS='${MAKE_PARALLEL_FLAGS}'."
+    elif [ -n "${MAKE_PARALLEL_JOBS-}" ]; then
+        echo "Building VPP. Number of cores for build set with" \
+             "MAKE_PARALLEL_JOBS='${MAKE_PARALLEL_JOBS}'."
+    else
+        echo "Building VPP. Number of cores not set, " \
+             "using build default ($(grep -c ^processor /proc/cpuinfo))."
+    fi
+
+    make UNATTENDED=y pkg-verify || die "VPP build with make pkg-verify failed."
     echo "* VPP ${1-} BUILD SUCCESSFULLY COMPLETED" || {
         die "Argument not found."
     }
-    echo "*******************************************************************"
 }
 
 
 function compare_test_results () {
 
-    set -exuo pipefail
-
     # Variables read:
     # - VPP_DIR - Path to directory with VPP git repo (at least built parts).
     # - ARCHIVE_DIR - Path to where robot result files are created in.
@@ -91,108 +69,134 @@ function compare_test_results () {
     #   of parent build.
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
-    # - parse_bmrr_results - See definition in this file.
     # Exit code:
     # - 0 - If the comparison utility sees no regression (nor data error).
     # - 1 - If the comparison utility sees a regression (or data error).
 
+    set -exuo pipefail
+
     cd "${VPP_DIR}" || die "Change directory operation failed."
     # Reusing CSIT main virtualenv.
-    pip install -r "${PYTHON_SCRIPTS_DIR}/perpatch_requirements.txt" || {
-        die "Perpatch Python requirements installation failed."
-    }
-    python "${PYTHON_SCRIPTS_DIR}/compare_perpatch.py"
+    python3 "${TOOLS_DIR}/integrated/compare_perpatch.py"
     # The exit code determines the vote result.
 }
 
 
-function download_builds () {
+function initialize_csit_dirs () {
 
     set -exuo pipefail
 
-    # This is mostly useful only for Sandbox testing, to avoid recompilation.
-    #
-    # Arguments:
-    # - ${1} - URL to download VPP builds from.
     # Variables read:
     # - VPP_DIR - Path to WORKSPACE, parent of created directories.
     # Directories created:
-    # - archive - Ends up empty, not to be confused with ${ARCHIVE_DIR}.
-    # - build_current - Holding built artifacts of the patch under test (PUT).
-    # - built_parent - Holding built artifacts of parent of PUT.
+    # - csit_{part} - See the caller what it is used for.
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     cd "${VPP_DIR}" || die "Change directory operation failed."
-    dirs=("build-root" "build_parent" "build_current" "archive" "csit_current")
-    rm -rf ${dirs[@]} || {
-        die "Directory removal failed."
-    }
-    wget -N --progress=dot:giga "${1}" || die "Wget download failed."
-    unzip "archive.zip" || die "Archive extraction failed."
-    mv "archive/build_parent" ./ || die "Move operation failed."
-    mv "archive/build_current" ./ || die "Move operation failed."
+    while true; do
+        if [[ ${#} < 1 ]]; then
+            # All directories created.
+            break
+        fi
+        name_part="${1}" || die
+        shift || die
+        dir_name="csit_${name_part}" || die
+        rm -rf "${dir_name}" || die "Directory deletion failed."
+        mkdir -p "${dir_name}" || die "Directory creation failed."
+    done
 }
 
 
-function initialize_csit_dirs () {
-
-    set -exuo pipefail
+function main_bisect_loop () {
 
-    # This could be in prepare_test, but download_builds also needs this.
+    # Perform the iterative part of bisect entry script.
     #
-    # Variables read:
-    # - VPP_DIR - Path to WORKSPACE, parent of created directories.
-    # Directories created:
-    # - csit_current - Holding test results of the patch under test (PUT).
-    # - csit_parent - Holding test results of parent of PUT.
-    # Functions called:
-    # - die - Print to stderr and exit, defined in common.sh
-
-    cd "${VPP_DIR}" || die "Change directory operation failed."
-    rm -rf "csit_current" "csit_parent" || {
-        die "Directory deletion failed."
-    }
-    mkdir -p "csit_current" "csit_parent" || {
-        die "Directory creation failed."
-    }
+    # The logic is too complex to remain in the entry script.
+    #
+    # At the start, the loop assumes git bisect old/new has just been executed,
+    # and verified more iterations are needed.
+    # The iteration cleans the build directory and builds the new mid commit.
+    # Then, testbed is reserved, tests run, and testbed unreserved.
+    # Results are moved from default to archive location
+    # (indexed by iteration number) and analyzed.
+    # The new adjective ("old" or "new") is selected,
+    # and git bisect with the adjective is executed.
+    # The symlinks csit_early and csit_late are updated to tightest bounds.
+    # The git.log file is examined and if the bisect is finished, loop ends.
+
+    iteration=0
+    while true
+    do
+        let iteration+=1
+        git clean -dffx "build"/ "build-root"/ || die
+        build_vpp_ubuntu "MIDDLE" || die
+        select_build "build-root" || die
+        check_download_dir || die
+        reserve_and_cleanup_testbed || die
+        run_robot || die
+        move_test_results "csit_middle/${iteration}" || die
+        untrap_and_unreserve_testbed || die
+        rm -vf "csit_mid" || die
+        ln -s -T "csit_middle/${iteration}" "csit_mid" || die
+        set +e
+        python3 "${TOOLS_DIR}/integrated/compare_bisect.py"
+        bisect_rc="${?}"
+        set -e
+        if [[ "${bisect_rc}" == "3" ]]; then
+            adjective="new"
+            rm -v "csit_late" || die
+            ln -s -T "csit_middle/${iteration}" "csit_late" || die
+        elif [[ "${bisect_rc}" == "0" ]]; then
+            adjective="old"
+            rm -v "csit_early" || die
+            ln -s -T "csit_middle/${iteration}" "csit_early" || die
+        else
+            die "Unexpected return code: ${bisect_rc}"
+        fi
+        git bisect "${adjective}" | tee "git.log" || die
+        git describe || die
+        git status || die
+        if head -n 1 "git.log" | cut -b -11 | fgrep -q "Bisecting:"; then
+            echo "Still bisecting..."
+        else
+            echo "Bisecting done."
+            break
+        fi
+    done
 }
 
 
-function parse_bmrr_results () {
-
-    set -exuo pipefail
+function move_test_results () {
 
-    # Currently "parsing" is just two greps.
-    # TODO: Re-use PAL parsing code, make parsing more general and centralized.
-    #
     # Arguments:
-    # - ${1} - Path to (existing) directory holding robot output.xml result.
-    # Files read:
-    # - output.xml - From argument location.
-    # Files updated:
-    # - results.txt - (Re)created, in argument location.
+    # - ${1}: Directory to archive to. Required. Parent has to exist.
+    # Variable set:
+    # - TARGET - Target archival directory, equivalent to the argument.
+    # Variables read:
+    # - ARCHIVE_DIR - Path to where robot result files are created in.
+    # - VPP_DIR - Path to existing directory, root for to relative paths.
+    # Directories updated:
+    # - ${1} - Created, and robot and parsing files are moved/created there.
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
-    rel_dir="$(readlink -e "${1}")" || die "Readlink failed."
-    in_file="${rel_dir}/output.xml"
-    out_file="${rel_dir}/results.txt"
-    # TODO: Do we need to check echo exit code explicitly?
-    echo "Parsing ${in_file} putting results into ${out_file}"
-    echo "TODO: Re-use parts of PAL when they support subsample test parsing."
-    pattern='Maximum Receive Rate trial results in packets'
-    pattern+=' per second: .*\]</status>'
-    grep -o "${pattern}" "${in_file}" | grep -o '\[.*\]' > "${out_file}" || {
-        die "Some parsing grep command has failed."
-    }
+    set -exuo pipefail
+
+    cd "${VPP_DIR}" || die "Change directory command failed."
+    TARGET="$(readlink -f "$1")"
+    mkdir -p "${TARGET}" || die "Directory creation failed."
+    file_list=("output.xml" "log.html" "report.html" "tests")
+    for filename in "${file_list[@]}"; do
+        mv "${ARCHIVE_DIR}/${filename}" "${TARGET}/${filename}" || die
+    done
 }
 
 
 function select_build () {
 
-    set -exuo pipefail
-
     # Arguments:
     # - ${1} - Path to directory to copy VPP artifacts from. Required.
     # Variables read:
@@ -205,6 +209,8 @@ function select_build () {
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     cd "${VPP_DIR}" || die "Change directory operation failed."
     source_dir="$(readlink -e "$1")"
     rm -rf "${DOWNLOAD_DIR}"/* || die "Cleanup of download dir failed."
@@ -214,76 +220,55 @@ function select_build () {
 }
 
 
-function set_aside_commit_build_artifacts () {
-
-    set -exuo pipefail
+function set_aside_build_artifacts () {
 
-    # Function is copying VPP built artifacts from actual checkout commit for
-    # further use and clean git.
+    # Function used to save VPP .deb artifacts from currently finished build.
+    #
+    # After the artifacts are copied to the target directory,
+    # the main git tree is cleaned up to not interfere with next build.
+    #
+    # Arguments:
+    # - ${1} - String to derive the target directory name from. Required.
     # Variables read:
     # - VPP_DIR - Path to existing directory, parent to accessed directories.
     # Directories read:
     # - build-root - Existing directory with built VPP artifacts (also DPDK).
     # Directories updated:
     # - ${VPP_DIR} - A local git repository, parent commit gets checked out.
-    # - build_current - Old contents removed, content of build-root copied here.
+    # - build_${1} - Old contents removed, content of build-root copied here.
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     cd "${VPP_DIR}" || die "Change directory operation failed."
-    rm -rf "build_current" || die "Remove operation failed."
-    mkdir -p "build_current" || die "Directory creation failed."
-    mv "build-root"/*".deb" "build_current"/ || die "Move operation failed."
+    dir_name="build_${1}" || die
+    rm -rf "${dir_name}" || die "Remove operation failed."
+    mkdir -p "${dir_name}" || die "Directory creation failed."
+    mv "build-root"/*".deb" "${dir_name}"/ || die "Move operation failed."
     # The previous build could have left some incompatible leftovers,
     # e.g. DPDK artifacts of different version (in build/external).
     # Also, there usually is a copy of dpdk artifact in build-root.
     git clean -dffx "build"/ "build-root"/ || die "Git clean operation failed."
-    # Finally, check out the parent commit.
-    git checkout HEAD~ || die "Git checkout operation failed."
-    # Display any other leftovers.
-    git status || die "Git status operation failed."
-}
-
-
-function set_aside_parent_build_artifacts () {
-
-    set -exuo pipefail
-
-    # Function is copying VPP built artifacts from parent checkout commit for
-    # further use. Checkout to parent is not part of this function.
-    # Variables read:
-    # - VPP_DIR - Path to existing directory, parent of accessed directories.
-    # Directories read:
-    # - build-root - Existing directory with built VPP artifacts (also DPDK).
-    # Directories updated:
-    # - build_parent - Old directory removed, build-root debs moved here.
-    # Functions called:
-    # - die - Print to stderr and exit, defined in common.sh
-
-    cd "${VPP_DIR}" || die "Change directory operation failed."
-    rm -rf "build_parent" || die "Remove failed."
-    mkdir -p "build_parent" || die "Directory creation operation failed."
-    mv "build-root"/*".deb" "build_parent"/ || die "Move operation failed."
+    git status || die
 }
 
 
 function set_perpatch_dut () {
 
-    set -exuo pipefail
-
     # Variables set:
     # - DUT - CSIT test/ subdirectory containing suites to execute.
 
     # TODO: Detect DUT from job name, when we have more than just VPP perpatch.
 
+    set -exuo pipefail
+
     DUT="vpp"
 }
 
 
 function set_perpatch_vpp_dir () {
 
-    set -exuo pipefail
-
     # Variables read:
     # - CSIT_DIR - Path to existing root of local CSIT git repository.
     # Variables set:
@@ -291,6 +276,8 @@ function set_perpatch_vpp_dir () {
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     # In perpatch, CSIT is cloned inside VPP clone.
     VPP_DIR="$(readlink -e "${CSIT_DIR}/..")" || die "Readlink failed."
 }